## scipy 1.15.3

=== scipy/_lib/boost_math/CMakeLists.txt ===
# Copyright 2020 Peter Dimov
# Copyright 2021 Matt Borland
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_math VERSION 1.87.0 LANGUAGES CXX)

add_library(boost_math INTERFACE)

add_library(Boost::math ALIAS boost_math)

target_include_directories(boost_math INTERFACE include)

include(CMakeDependentOption)

cmake_dependent_option(BOOST_MATH_STANDALONE "Use Boost.Math in standalone mode" ON "NOT BOOST_SUPERPROJECT_VERSION" OFF)

message(STATUS "Boost.Math: standalone mode ${BOOST_MATH_STANDALONE}")

if(BOOST_MATH_STANDALONE)

  target_compile_definitions(boost_math INTERFACE BOOST_MATH_STANDALONE=1)

else()

  target_link_libraries(boost_math
    INTERFACE
      Boost::assert
      Boost::concept_check
      Boost::config
      Boost::core
      Boost::integer
      Boost::lexical_cast
      Boost::predef
      Boost::random
      Boost::static_assert
      Boost::throw_exception
  )

endif()

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

# Only enable tests when we're the root project
elseif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)

  include(CTest)
  add_subdirectory(test)
  
  include(GNUInstallDirs)
  install(DIRECTORY "include/" DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

endif()

=== scipy/interpolate/fitpack/Makefile ===
# Makefile that builts a library lib$(LIB).a from all
# of the Fortran files found in the current directory.
# Usage: make LIB=<libname>
# Pearu

OBJ=$(patsubst %.f,%.o,$(shell ls *.f))
all: lib$(LIB).a
$(OBJ):
	$(FC) -c $(FFLAGS) $(FSHARED) $(patsubst %.o,%.f,$(@F)) -o $@
lib$(LIB).a: $(OBJ)
	$(AR) rus lib$(LIB).a $?
clean:
	rm *.o

=== subprojects/highs/check/CMakeLists.txt ===
include(CTest)

if (FORTRAN)
    set(CMAKE_Fortran_MODULE_DIRECTORY ${HIGHS_BINARY_DIR}/modules)
    add_executable(fortrantest TestFortranAPI.f90)
    if (NOT FAST_BUILD)
        target_link_libraries(fortrantest libhighs FortranHighs)
    else()
        target_link_libraries(fortrantest highs FortranHighs)
    endif()
    target_include_directories(fortrantest PUBLIC 
        ${HIGHS_SOURCE_DIR}/src/interfaces
        ${HIGHS_SOURCE_DIR}/check)
endif()

if (NOT FAST_BUILD OR ALL_TESTS)
  # prepare Catch library
  set(CATCH_INCLUDE_DIR ${HIGHS_SOURCE_DIR}/extern)
  add_library(Catch INTERFACE)
  target_include_directories(Catch INTERFACE ${CATCH_INCLUDE_DIR})

  configure_file(${HIGHS_SOURCE_DIR}/check/HCheckConfig.h.in ${HIGHS_BINARY_DIR}/HCheckConfig.h)

  FILE(WRITE ${CMAKE_BINARY_DIR}/testoptions.txt
  "mip_rel_gap=0.0
  mip_abs_gap=0.0")

  # Make test executable
  set(TEST_SOURCES
      TestHighsVersion.cpp
      TestAlienBasis.cpp
      TestDualize.cpp
      TestCallbacks.cpp
      TestCheckSolution.cpp
      TestEkk.cpp
      TestFactor.cpp
      TestFreezeBasis.cpp
      TestHotStart.cpp
      TestMain.cpp
      TestNames.cpp
      TestOptions.cpp
      TestIO.cpp
      TestSort.cpp
      TestSetup.cpp
      TestFilereader.cpp
      TestHighsGFkSolve.cpp
      TestInfo.cpp
      TestBasis.cpp
      TestBasisSolves.cpp
      TestCrossover.cpp
      TestHighsHash.cpp
      TestHighsIntegers.cpp
      TestHighsParallel.cpp
      TestHighsRbTree.cpp
      TestHighsHessian.cpp
      TestHighsModel.cpp
      TestHighsSparseMatrix.cpp
      TestHSet.cpp
      TestICrash.cpp
      TestIis.cpp
      TestIpm.cpp
      TestIpx.cpp
      TestLogging.cpp
      TestLPFileFormat.cpp
      TestLpValidation.cpp
      TestLpModification.cpp
      TestLpOrientation.cpp
      TestModelProperties.cpp
      TestPdlp.cpp
      TestPresolve.cpp
      TestQpSolver.cpp
      TestRays.cpp
      TestRanging.cpp
      TestSemiVariables.cpp
      TestThrow.cpp
      TestTspSolver.cpp
      TestUserScale.cpp
      Avgas.cpp)

  # todo: IG
  if (NOT APPLE)
      # Bug with updated IPX code and gas11. Maybe somehow related to the rpath on 
      # macOS (Lukas). Only triggered by gas11 with no presolve which is strange. 
      # may be an interface related issue which will pop up soon. 
      # works OK on linux. The test was added to doctest for macOS but still hanging.
      set(TEST_SOURCES ${TEST_SOURCES} TestSpecialLps.cpp TestLpSolvers.cpp TestMipSolver.cpp)
  endif()

  add_executable(unit_tests ${TEST_SOURCES})
  if (UNIX)
      target_compile_options(unit_tests PRIVATE "-Wno-unused-variable")
      target_compile_options(unit_tests PRIVATE "-Wno-unused-const-variable")
  endif()

  if (FAST_BUILD)
    target_link_libraries(unit_tests highs Catch)
  else()
    target_link_libraries(unit_tests libhighs Catch)
  endif()

  include(GNUInstallDirs)
  if(APPLE)
      set_target_properties(unit_tests PROPERTIES INSTALL_RPATH
      "@loader_path/../${CMAKE_INSTALL_LIBDIR};@loader_path")
  elseif(UNIX)
      cmake_path(RELATIVE_PATH CMAKE_INSTALL_FULL_LIBDIR
          BASE_DIRECTORY ${CMAKE_INSTALL_FULL_BINDIR}
          OUTPUT_VARIABLE libdir_relative_path)
      set_target_properties(unit_tests PROPERTIES 
      INSTALL_RPATH "$ORIGIN/${libdir_relative_path}")
  endif()


  # check the C API
  add_executable(capi_unit_tests TestCAPI.c)

  if (FAST_BUILD)
    target_link_libraries(capi_unit_tests highs)
  else()
    target_link_libraries(capi_unit_tests libhighs)
  endif()

  add_test(NAME capi_unit_tests COMMAND capi_unit_tests)

  # Check whether test executable builds OK.
  add_test(NAME unit-test-build
          COMMAND ${CMAKE_COMMAND}
                  --build ${HIGHS_BINARY_DIR}
                  --target unit_tests
                  #  --config ${CMAKE_BUILD_TYPE}
          )


  # Avoid that several build jobs try to concurretly build.
  set_tests_properties(unit-test-build
                      PROPERTIES
                      RESOURCE_LOCK unittestbin)

  # create a binary running all the tests in the executable
  add_test(NAME unit_tests_all COMMAND unit_tests --success)
  set_tests_properties(unit_tests_all
                      PROPERTIES
                      DEPENDS unit-test-build)
  set_tests_properties(unit_tests_all PROPERTIES TIMEOUT 10000) 

  # An individual test can be added with the command below but the approach
  # above with a single add_test for all the unit tests automatically detects all
  # TEST_CASEs in the source files specified in TEST_SOURCES. Do not define any
  # tests in TestMain.cpp and do not define CATCH_CONFIG_MAIN anywhere else.
  # add_test(NAME correct-print-test COMMAND unit_tests correct-print)

  # --------------------------------------
  # Another way of adding the tests. Needs a script from github repo and a
  # Catch2 installation. So add tests manually if there is no build issues.
  # catch_discover_tests(unit_test)

  # --------------------------------------
  # Run instance tests.
  #
  # define the set of feasible instances
  set(successInstances
      "25fv47\;3149\; 5.5018458883\;"
      "80bau3b\;3686\; 9.8722419241\;"
      "adlittle\;74\; 2.2549496316\;"
      "afiro\;22\;-4.6475314286\;"
      "etamacro\;532\;-7.5571523330\;"
      "greenbea\;5109\;-7.2555248130\;"
      "shell\;623\; 1.2088253460\;"
      "stair\;529\;-2.5126695119\;"
      "standata\;72\; 1.2576995000\;"
      "standgub\;68\; 1.2576995000\;"
      "standmps\;218\; 1.4060175000\;"
      )
  
   set(successMacArmInstances
      "25fv47\;3103\; 5.5018458883\;"
      "80bau3b\;3705\; 9.8722419241\;"
      "adlittle\;74\; 2.2549496316\;"
      "afiro\;22\;-4.6475314286\;"
      "etamacro\;531\;-7.5571523330\;"
      "greenbea\;5156\;-7.2555248130\;"
      "shell\;623\; 1.2088253460\;"
      "stair\;531\;-2.5126695119\;"
      "standata\;72\; 1.2576995000\;"
      "standgub\;68\; 1.2576995000\;"
      "standmps\;218\; 1.4060175000\;"
   )

  set(infeasibleInstances
      "bgetam\;        infeasible"
      "box1\;          infeasible"
      "ex72a\;         infeasible"
      "forest6\;       infeasible"
      "galenet\;       infeasible"
      "gams10am\;      infeasible"
  #    "klein1\;        infeasible"
      "refinery\;      infeasible"
      "woodinfe\;      infeasible"
      )

  set(unboundedInstances
      "gas11\;         unbounded"
      )

  set(failInstances
      )
  
  set(mipInstances 
      "small_mip\;3.2368421\;"
      "flugpl\;1201500\;"
      "lseu\;1120|1119.9999999\;"
      "egout\;(568.1007|568.1006999)\;"
      "gt2\;21166\;"
      "rgn\;82.1999992\;"
      "bell5\;(8966406.49152|8966406.491519|8966406.49151)\;"
      "sp150x300d\;(69|68.9999999)\;"
      "p0548\;(8691|8690.9999999)\;"
      "dcmulti\;188182\;"
      )

  # define settings
  set(settings
      "--presolve=off"
      "--presolve=on"
      "--random_seed=1"
      "--random_seed=2"
      "--random_seed=3"
  #   "--random_seed=4"
  #   "--random_seed=5"
  #   "--parallel=on"
      )

  if (UNIX AND NOT APPLE)
    set(pdlpInstances
        "25fv47\; 5.50184588\;"
        "adlittle\; 2.254949631\;"
        "afiro\;-4.64753142\;"
        "avgas\;-7.749999999\;"
        "blending\;-3.19999999\;"
        "chip\;-9.000000001\;"
        "e226\;-1.16389293\;"
        "scrs8\; 9.042969511\;"
        "sctest\; 5.749999936\;"
        "shell\; 1.2088253460\;"
        "stair\;-2.51266951\;"
        "standata\; 1.257699499\;"
        "standgub\; 1.25769949\;"
        )
  elseif(WIN32)
    # on windows e226 model status is unknown, rel gap e00
    set(pdlpInstances
        "25fv47\; 5.50184588\;"
        "adlittle\; 2.25494963\;"
        "afiro\;-4.64753142\;"
        "avgas\;-7.749999999\;"
        "blending\;-3.19999999\;"
        "chip\;-9.000000001\;"
        "scrs8\; 9.0429695\;"
        "sctest\; 5.749999936\;"
        "shell\; 1.2088253460\;"
        "stair\;-2.51266951\;"
        "standata\; 1.2576995\;"
        "standgub\; 1.2576995\;"
        )
  elseif(APPLE)
    set(pdlpInstances
        "25fv47\; 5.5018458\;"
        "adlittle\; 2.25494963\;"
        "afiro\;-4.64753142\;"
        "avgas\;-7.749999999\;"
        "blending\;-3.19999999\;"
        "chip\;-8.9999988715\;"
        "e226\;-1.163892\;"
        "scrs8\; 9.04296953\;"
        "sctest\; 5.749999936\;"
        "shell\; 1.2088253460\;"
        "stair\;-2.5126695\;"
        "standata\; 1.25769950\;"
        "standgub\; 1.25769950\;"
    )
  endif()


  # define a macro to add tests
  #
  # add_instancetests takes an instance group and a status
  # that the solver should report as arguments
  macro(add_instancetests instances solutionstatus)
  # loop over the instances
  foreach(instance ${${instances}})
      # add default tests
      # treat the instance as a tuple (list) of two values
      list(GET instance 0 name)
      list(GET instance 1 iter)

      if(${solutionstatus} STREQUAL "Optimal")
          list(GET instance 2 optval)
      endif()

      # specify the instance and the settings load command
      if(ZLIB AND ZLIB_FOUND AND EXISTS "${HIGHS_SOURCE_DIR}/check/instances/${name}.mps.gz")
        set(inst "${HIGHS_SOURCE_DIR}/check/instances/${name}.mps.gz")
      else()
        set(inst "${HIGHS_SOURCE_DIR}/check/instances/${name}.mps")
      endif()

      # loop over all settings
      foreach(setting ${settings})
          if (FAST_BUILD)
            add_test(NAME ${name}${setting} COMMAND $<TARGET_FILE:highs-bin> ${setting}
                ${inst})
          else()
            add_test(NAME ${name}${setting} COMMAND $<TARGET_FILE:highs> ${setting}
                ${inst})
          endif()

          set_tests_properties (${name}${setting} PROPERTIES
                  DEPENDS unit_tests_all)
          set_tests_properties (${name}${setting} PROPERTIES
                  PASS_REGULAR_EXPRESSION
                  "Model status        : ${solutionstatus}")

          if(${solutionstatus} STREQUAL "Optimal")
              if(${setting} STREQUAL "--presolve=off")
                  set_tests_properties (${name}${setting} PROPERTIES
                          PASS_REGULAR_EXPRESSION
                          "Simplex   iterations: ${iter}\nObjective value     : ${optval}")
              else()
                  set_tests_properties (${name}${setting} PROPERTIES
                          PASS_REGULAR_EXPRESSION
                          "Objective value     : ${optval}")
              endif()
          endif()
      endforeach(setting)
  endforeach(instance)
  endmacro(add_instancetests)

  # add tests for success and fail instances
  if (APPLE AND (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "arm64"))
    add_instancetests(successMacArmInstances "Optimal")
  else()
    add_instancetests(successInstances "Optimal")
  endif()

  add_instancetests(failInstances "Fail")
  add_instancetests(infeasibleInstances "Infeasible")
  add_instancetests(unboundedInstances "Unbounded")


  foreach(instance ${mipInstances})
      list(GET instance 0 name)
      list(GET instance 1 optval)
      # specify the instance and the settings load command
      set(inst "${HIGHS_SOURCE_DIR}/check/instances/${name}.mps")

      foreach(setting ${settings})
          if (FAST_BUILD)
            add_test(NAME ${name}${setting} COMMAND $<TARGET_FILE:highs-bin> ${setting} 
                --options_file ${CMAKE_BINARY_DIR}/testoptions.txt ${inst})
          else()
            add_test(NAME ${name}${setting} COMMAND $<TARGET_FILE:highs> ${setting}
                --options_file ${CMAKE_BINARY_DIR}/testoptions.txt ${inst})
          endif()

          set_tests_properties (${name}${setting} PROPERTIES
                  DEPENDS unit_tests_all)

          set_tests_properties (${name}${setting} PROPERTIES
                  PASS_REGULAR_EXPRESSION
                  "Status            Optimal\n  Primal bound      ${optval}.*\n  Dual bound        ${optval}.*\n  Solution status   feasible\n                    ${optval}.* \\(objective\\)"

=== scipy/_lib/array_api_extra/docs/requirements.txt ===
furo>=2023.08.17
myst_parser>=0.13
sphinx>=7.0
sphinx_autodoc_typehints
sphinx_copybutton

=== scipy/_lib/boost_math/test/compile_test/CMakeLists.txt ===
# Copyright 2021 Matt Borland
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

file(GLOB SOURCES "*.cpp")
add_library(boost_math-compile_tests STATIC ${SOURCES})
target_compile_features(boost_math-compile_tests PRIVATE cxx_std_17)
target_link_libraries(boost_math-compile_tests PUBLIC Boost::math Boost::multiprecision Boost::numeric_ublas)

=== debian/changelog ===
scipy (1.15.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change upload for IEEE long double on ppc64el.

 -- Matthias Klose <doko@debian.org>  Fri, 05 Sep 2025 14:44:06 +0200

scipy (1.15.3-1) unstable; urgency=medium

  * New upstream bug-fix release
    - applies debian patches ndimage_pytest_safety_PR22828.patch
      and ndimage_segfault_filter_mirror_PR22608.patch

 -- Drew Parsons <dparsons@debian.org>  Sun, 11 May 2025 11:41:19 +0200

scipy (1.15.2-8) unstable; urgency=medium

  * debian patch ndimage_pytest_safety_PR22828.patch applies upstream
    PR#22828 to make ndimage safer to use with pytest
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Mon, 14 Apr 2025 23:05:55 +0200

=== debian/control ===
Source: scipy
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>,
           Ondrej Certik <ondrej@certik.cz>,
           David Cournapeau <cournape@gmail.com>,
           Varun Hiremath <varun@debian.org>
Section: python
Priority: optional
Build-Depends: cython3,
               debhelper-compat (= 13),
               dh-sequence-python3,
               pybuild-plugin-pyproject,
               gfortran,
               libblas-dev,
               liblapack-dev,
               libsuitesparse-dev,
               python3-mesonpy (>= 0.15.0~),
               pkgconf,
               python3-all-dev,
               python3-decorator,
               python3-numpy (>= 1:1.26.0~),
               python3-pooch,
               python3-pybind11 (>= 2.13.2~),
               python3-setuptools,
               python3-wheel,
               python3-pythran (>= 0.15.0~),
               python3-pytest,
               python3-doit (>= 0.36.0~) <!nocheck>,
               python3-hypothesis <!nocheck>,
               python3-yaml
Build-Depends-Indep: dvipng,
                     dh-sequence-sphinxdoc,
                     python3-doc <!nodoc>,
                     python3-docutils,
                     python3-sphinx-copybutton <!nodoc>,
                     python3-jupytext <!nodoc>,
                     python3-matplotlib,
                     python-matplotlib-doc <!nodoc>,
                     python-mpmath-doc <!nodoc>,
                     python3-myst-nb <!nodoc>,
                     python-numpy-doc <!nodoc>,
                     python3-numpydoc <!nodoc>,
                     python3-pydata-sphinx-theme,
                     python3-sphinx,
                     python3-sphinx-design,
                     python3-sphinx-tabs,
                     python-statsmodels-doc <!nodoc>,
                     rdfind,
                     symlinks,
                     texlive-latex-base,
                     texlive-latex-extra
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/python-team/packages/scipy
Vcs-Git: https://salsa.debian.org/python-team/packages/scipy.git
Homepage: https://www.scipy.org/
Rules-Requires-Root: no

Package: python3-scipy
Architecture: any
Multi-Arch: no
Depends: python3-decorator,
         python3-numpy (>= 1:1.26.0~),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: g++ | c++-compiler,
            python3-pil,
            python3-pooch,
            python3-yaml
Suggests: python-scipy-doc
Breaks: python3-skbio (<< 0.5.8-3~)
Description: scientific tools for Python 3
 SciPy supplements the popular NumPy module (python-numpy package), gathering a
 variety of high level science and engineering modules together as a single
 package.
 .
 SciPy is a set of Open Source scientific and numeric tools for Python. It
 currently supports special functions, integration, ordinary differential
 equation (ODE) solvers, gradient optimization, genetic algorithms, parallel
 programming tools, an expression-to-C++ compiler for fast execution, and
 others.

Package: python-scipy-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: fonts-open-sans,
         libjs-jquery,
         libjs-mathjax,
         libjs-underscore,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: scientific library for Python - documentation
 SciPy supplements the popular NumPy module (python-numpy package), gathering a
 variety of high level science and engineering modules together as a single
 package.
 .
 SciPy is a set of Open Source scientific and numeric tools for Python. It
 currently supports special functions, integration, ordinary differential
 equation (ODE) solvers, gradient optimization, genetic algorithms, parallel
 programming tools, an expression-to-C++ compiler for fast execution, and
 others.
 .
 This package contains documentation for the SciPy library.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=scipy

include /usr/share/dpkg/default.mk

unexport LDFLAGS
export FFLAGS="-fPIC"
export ATLAS=None
export PATH := $(CURDIR)/debian/extra_bin:$(PATH)
export SCIPY_USE_PYTHRAN=0

PY3VERS:= $(shell py3versions -v -s)
PY3_DEFAULT:= $(shell py3versions -dv)
TMPDIR := $(CURDIR)/build/tmp
BASE=$(shell pwd)/debian

export SCIPY_USE_PYTHRAN = $(shell if dpkg-query -s python3-pythran >/dev/null 2>/dev/null; then echo 1; else echo 0; fi )

# specify build against generic BLAS/LAPACK. Preferred optimised implementation should be installed
# by the end user, not by the package build.
export PYBUILD_BUILD_ARGS := -Csetup-args=-Dblas=blas -Csetup-args=-Dlapack=lapack

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  export NPY_NUM_BUILD_JOBS = $(DEB_BUILD_OPTION_PARALLEL)
  export PYBUILD_BUILD_ARGS += -Ccompile-args=-j$(DEB_BUILD_OPTION_PARALLEL)
endif

# identify if any tests are particularly slow
EXTRA_TEST_FLAGS += --durations=20

# some arches time out. Run verbose to see where they got stuck.
VERBOSE_ARCH_LIST := mips64el riscv64 sparc64

# 32-bit stability degraded in scipy 1.12 with more tests
# getting MemoryError, especially in stats tests
# Run verbose to track more closely.
ifneq (,$(findstring $(DEB_HOST_ARCH_BITS), 32))
    VERBOSE_ARCH_LIST += $(DEB_HOST_ARCH)
endif

ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(VERBOSE_ARCH_LIST)$(space)))
    EXTRA_TEST_FLAGS += -v
endif

# stats/tests/test_continuous_basic.py::test_cont_basic[500-200-ncf-arg74] test fails with IntegrationWarning
# https://github.com/scipy/scipy/issues/14519
# test_data (pooch) needs internet or cached data files
SKIP_TEST_LIST += test_cont_basic[500-200-ncf-arg74] test_existence_all test_ascent test_face test_electrocardiogram

# multi-Ellipsis indexing in sparse will be dropped in scipy 1.13
# see https://github.com/scipy/scipy/pull/18541
# it fails tests now so skip and reinstate later for scipy 1.13
SKIP_TEST_LIST += test_multiple_ellipsis_slicing

ifneq (,$(findstring $(DEB_HOST_ARCH), arm64))
    SKIP_TEST_LIST += test_maxiter_worsening[lgmres]
endif

# linalg/tests/test_decomp.py started segfaulting on armel
ifneq (,$(findstring $(DEB_HOST_ARCH), armel))
    SKIP_TEST_LIST += test_decomp test_random_exact test_brunnermunzel_normal_dist test_sparse_dense_divide
    SKIP_TEST_LIST += test_some_code_paths test_gh12218 test_random_state
    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_bootstrap_against_R test_bootstrap_against_itself_1samp
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), armhf))
    SKIP_TEST_LIST += test_gh12218 test_random_state
    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_bootstrap_against_R test_bootstrap_against_itself_1samp
endif

# some tests broken on i386, see https://github.com/scipy/scipy/issues/17839
ifneq (,$(findstring $(DEB_HOST_ARCH), i386))
    SKIP_TEST_LIST += test_find_peaks_exact test_find_peaks_withnoise test_x0_equals_Mb[bicgstab] test_rv_sample
    SKIP_TEST_LIST += test_location_scale[pdf test_examples[True-float64] test_pdf_nolan_samples test_cdf_nolan_samples
    SKIP_TEST_LIST += ellint_rg_xy0_ipp-ellint_rg_xy0 test_hermitian test_random_state
    SKIP_TEST_LIST += test_against_anderson_gumbel_r test_bootstrap_against_R test_bootstrap_against_itself_1samp
    SKIP_TEST_LIST += test_svd_gesdd_nofegfault
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), mips64el))
    # integrate/_ivp/tests/test_ivp.py fail on mips64el
    # see https://github.com/scipy/scipy/issues/16883
    # https://github.com/scipy/scipy/issues/17839#issuecomment-1400636840
    SKIP_TEST_LIST += test_first_step test_classes test_integrality test_integrator test_double_integrator
    SKIP_TEST_LIST += test_nanminmax TestLogM TestExpmFrechet
    SKIP_TEST_LIST += test_2x2_input test_nx2x2_input test_random_matrices_and_powers
    # there are also further complex number problems with numpy 2 on mips64el
    # again see Bug#1094477 and https://github.com/scipy/scipy/issues/21393
    SKIP_TEST_LIST += TestCephes TestEllipCarlson TestErf TestFresnel TestHyper
    SKIP_TEST_LIST += test_boost TestHyp1f1 test_nan_inputs[wofz] test_eval_chebyt_gh20129
    SKIP_TEST_LIST += test_sici_consistency test_shichi_consistency test_wrightomega
    SKIP_TEST_LIST += test_cont_basic test_norm_logcdf
    # nan arrays are failing tests, https://github.com/scipy/scipy/issues/22360
    SKIP_TEST_LIST += test_nan_array
    SKIP_TEST_LIST += test_axis_nan_policy_axis_is_None[all_nans-propagate-ttest_ci \
	test_axis_nan_policy_axis_is_None[mixed-propagate-iqr \
	test_axis_nan_policy_axis_is_None[mixed-propagate-ttest_ci \
	test_axis_nan_policy_axis_is_None[mixed-propagate-xp \
	test_axis_nan_policy_axis_is_None[mixed-omit-xp_var
endif

# https://github.com/scipy/scipy/issues/17839#issuecomment-1401780853
ifneq (,$(findstring $(DEB_HOST_ARCH), riscv64))
    SKIP_TEST_LIST += test_maxiter_worsening[lgmres] test_milp_timeout_16545
endif

# test_atol[bicg] only just misses tolerance on s390x, but the design of the test makes it difficult to workaround,
# so skip. See https://github.com/scipy/scipy/issues/17839#issuecomment-1399477182
ifneq (,$(findstring $(DEB_HOST_ARCH), s390x))
    SKIP_TEST_LIST += test_maxiter_worsening test_atol[bicg] test_distance_transform_cdt05
endif

# Bug#1017864 test_kolmogorov.py segfaults on i386 (including hurd)
SKIP_KOLMOGOROV_ARCH_LIST := i386 hurd-i386
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_KOLMOGOROV_ARCH_LIST)$(space)))
    SKIP_TEST_LIST += TestSmirnovp
endif

# some tests in linalg test_matfuncs.py fail on several arches
# in particular riscv64 hppa sparc64 share many common test failure
SKIP_TestLogM_ARCH_LIST := riscv64 hppa sparc64
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_TestLogM_ARCH_LIST)$(space)))
    SKIP_TEST_LIST += TestLogM TestExp test_expm
    SKIP_TEST_LIST += test_random_matrices_and_powers test_2x2_input test_nx2x2_input
    SKIP_TEST_LIST += test_zoh test_foh test_transferfunction
    SKIP_TEST_LIST += test_zerospolesgain test_discrete_approx test_simo_tf test_multioutput
    SKIP_TEST_LIST += test_simo_tf test_multioutput TestC2dLti TestC2dInvariants
    SKIP_TEST_LIST += test_second_order test_integrator test_double_integrator
    SKIP_TEST_LIST += test_jordan_block test_array_like TestStep test_operators
    SKIP_TEST_LIST += test_nan_inputs[airye] test_nan_inputs[sph_harm]
endif

# some archs fail test_cython (special test_extending) with numpy 1.26
# but will pass with numpy 2 due to complex type changes
# see https://github.com/scipy/scipy/issues/21393
SKIP_NEEDS_NUMPY2_ARCH_LIST := mips64el alpha hppa powerpc ppc64
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(SKIP_NEEDS_NUMPY2_ARCH_LIST)$(space)))
    SKIP_TEST_LIST += test_cython
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), alpha))
    SKIP_TEST_LIST += test_read_over64bit_integer_dense test_read_over64bit_integer_sparse
    SKIP_TEST_LIST += test_hyp0f1 test_eval_chebyt_gh20129 test_rvs_gh18372
endif

# hppa runs out of memory in test_bootstrap_against_theory
ifneq (,$(findstring $(DEB_HOST_ARCH), hppa))
    SKIP_TEST_LIST += test_nodata test_cont_basic[500-200-semicircular-arg89] test_bootstrap_against_theory test_distance_transform_cdt05
    SKIP_TEST_LIST += test_onenormest_linear_operator test_against_anderson_gumbel_r test_gh12218
    SKIP_TEST_LIST += test_roots_hermite_asy test_bootstrap_against_R bootstrap_against_itself test_against_f_oneway
    SKIP_TEST_LIST += test_QRVS_shape_consistency[1-d_out1-1-size_out1-qrng1-NumericalInversePolynomial] \
	test_QRVS_shape_consistency[None-d_out0-size_in4-size_out4-None-NumericalInversePolynomial] \
	test_QRVS_shape_consistency[None-d_out0-size_in4-size_out4-qrng1-NumericalInversePolynomial] \
	test_QRVS_shape_consistency[None-d_out0-size_in4-size_out4-qrng2-NumericalInversePolynomial] \

=== debian/watch ===
version=4
opts="uversionmangle=s/rc/~rc/, \
 filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
 https://github.com/scipy/scipy/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## scipy 1.16.0

=== debian/changelog ===
scipy (1.16.0-1exp7) experimental; urgency=medium

  * update debian patch test_nan_policy_array_22360.patch to skip test
    on any unexpected exception (the previous patch failed on
    FloatingPointError rather than RuntimeWarning).
    Include all_nans-propagate-ttest_ci in skip tests.

 -- Drew Parsons <dparsons@debian.org>  Mon, 30 Jun 2025 14:37:41 +0200

scipy (1.16.0-1exp6) experimental; urgency=medium

  * hppa: skip another test_QRVS_shape_cons [-NumericalInversePolynomial]
  * replace debian patch test_nan_policy_array_22360.patch with patch
    testing for misbehaviour with nans in np.mean in selected cases
    for test_axis_nan_policy_axis_is_None, skipping if RuntimeWarning
    is emitted. Drop mips64el axis_nan_policy skips in debian tests.
    See https://github.com/scipy/scipy/issues/22360

 -- Drew Parsons <dparsons@debian.org>  Mon, 30 Jun 2025 11:20:13 +0200

scipy (1.16.0-1exp5) experimental; urgency=medium

  * update test skips
    - mips64el:  weightedtau variants of test_axis_nan_policy_axis_is_None
      (upstream Issue#22360)
    - hppa powerpc: test_elementwise_multiply in TestCSC and TestBSR sparse
    - sparc64: expm1 log1p xlog1py and xlogy variants in test_cython_api
      (upstream Issue#22577)
    - hurd-i386: stats TestGoodnessOfFit (fails, exceeds Memory)

 -- Drew Parsons <dparsons@debian.org>  Fri, 27 Jun 2025 21:50:47 +0200

scipy (1.16.0-1exp4) experimental; urgency=medium

  * include path to newly built scipy module when extracting
    version details before build-time tests

 -- Drew Parsons <dparsons@debian.org>  Fri, 27 Jun 2025 14:38:07 +0200

scipy (1.16.0-1exp3) experimental; urgency=medium

  * read SciPy/NumPy/Python version and system information
    for build-time tests (needed if we must report a bug upstream)

 -- Drew Parsons <dparsons@debian.org>  Fri, 27 Jun 2025 12:01:33 +0200

scipy (1.16.0-1exp2) experimental; urgency=medium

  * debian/rules: when handling subprojects in submodules, allow for
    builds with (.dsc) and without (git) empty dirs in subprojects,
    since git removes empty dirs

 -- Drew Parsons <dparsons@debian.org>  Wed, 25 Jun 2025 13:06:47 +0200

scipy (1.16.0-1exp1) experimental; urgency=medium

  * New upstream major release
    - obsoletes debian patch special_libsf_error_SOABI.patch
      (libsf_error_state removed, upstream PR#22419)
  * update debian/copyright
    - update xsf entries
      - moved from scipy/special to submodules/subprojects/xsf
      - xsf includes faddeeva.h
      - xsf/cephes includes dd_real.h (Name: qd)
      - xsf adds kokkos/mdspan.hpp (2022 NTESS Apache-2.0)
    - boost_math moved from ../scipy/_lib to submodules/subprojects
    - qhull source moved from scipy/spatial/qhull_src/
      to subprojects/qhull_r/libqhull_r/
    - add scipy/spatial/src/distance_impl.h and distance_wrap.c
      Copyright: 2007, 2008, Damian Eads, BSD-3-clause
    - add scipy/_lib/pyprima,2020-2025, Zaikun ZHANG, BSD-3-clause
      PRIMA is a modern reimplementation of Powell's methods (COBYLA)
      If you use PRIMA, please cite DOI:10.5281/zenodo.8052654
    - list submodules in alphabetical order
  * debian/rules: link git submodules to their rightful places in
    subprojects (not all subprojects are git submodules)
  * Build scipy (spatial) against system qhull library.
    Build-Depends: libqhull-dev

 -- Drew Parsons <dparsons@debian.org>  Tue, 24 Jun 2025 23:12:34 +0200

=== debian/control ===
--- 
+++ 
@@ -13,6 +13,7 @@
                gfortran,
                libblas-dev,
                liblapack-dev,
+               libqhull-dev,
                libsuitesparse-dev,
                python3-mesonpy (>= 0.15.0~),
                pkgconf,

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,7 @@
 
 # specify build against generic BLAS/LAPACK. Preferred optimised implementation should be installed
 # by the end user, not by the package build.
-export PYBUILD_BUILD_ARGS := -Csetup-args=-Dblas=blas -Csetup-args=-Dlapack=lapack
+export PYBUILD_BUILD_ARGS := -Csetup-args=-Dblas=blas -Csetup-args=-Dlapack=lapack -Csetup-args=-Duse-system-libraries=qhull
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
   export NPY_NUM_BUILD_JOBS = $(DEB_BUILD_OPTION_PARALLEL)
@@ -91,13 +91,6 @@
     SKIP_TEST_LIST += test_boost TestHyp1f1 test_nan_inputs[wofz] test_eval_chebyt_gh20129
     SKIP_TEST_LIST += test_sici_consistency test_shichi_consistency test_wrightomega
     SKIP_TEST_LIST += test_cont_basic test_norm_logcdf
-    # nan arrays are failing tests, https://github.com/scipy/scipy/issues/22360
-    SKIP_TEST_LIST += test_nan_array
-    SKIP_TEST_LIST += test_axis_nan_policy_axis_is_None[all_nans-propagate-ttest_ci \
-	test_axis_nan_policy_axis_is_None[mixed-propagate-iqr \
-	test_axis_nan_policy_axis_is_None[mixed-propagate-ttest_ci \
-	test_axis_nan_policy_axis_is_None[mixed-propagate-xp \
-	test_axis_nan_policy_axis_is_None[mixed-omit-xp_var
 endif
 
 # https://github.com/scipy/scipy/issues/17839#issuecomment-1401780853
@@ -153,3 +146,8 @@
 	test_QRVS_shape_consistency[None-d_out0-size_in4-size_out4-None-NumericalInversePolynomial] \
 	test_QRVS_shape_consistency[None-d_out0-size_in4-size_out4-qrng1-NumericalInversePolynomial] \
 	test_QRVS_shape_consistency[None-d_out0-size_in4-size_out4-qrng2-NumericalInversePolynomial] \
+	test_QRVS_shape_consistency[1-d_out1-size_in3-size_out3-None-NumericalInversePolynomial] \
+	test_QRVS_shape_consistency[1-d_out1-size_in4-size_out4-None-NumericalInversePolynomial] \
+	test_QRVS_shape_consistency[1-d_out1-size_in4-size_out4-qrng1-NumericalInversePolynomial] \
+	test_QRVS_shape_consistency[1-d_out1-size_in4-size_out4-qrng2-NumericalInversePolynomial] \
+	test_QRVS_shape_consistency[1-d_out1-4-size_out2-qrng1-NumericalInversePolynomial] \

## scipy 1.16.2

=== doc/Makefile ===
# Makefile for Sphinx documentation

# If `python3` doesn't point to the Python you want to use (with Sphinx installed),
# then you can use, e.g., `make html PYTHON=python3.9` to specify a Python executable
PYTHON = python3

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = LANG=C $(PYTHON) -msphinx

# Environment variables needed for notebooks (see gh-17322):
export SQLALCHEMY_SILENCE_UBER_WARNING?=1
export JUPYTER_PLATFORM_DIRS?=1

FILES=

# Internal variables.
ALLSPHINXOPTS   = -d build/doctrees $(SPHINXOPTS) source

.PHONY: help clean html changes linkcheck dist version-check

#------------------------------------------------------------------------------

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  pickle    to make pickle files (usable by e.g. sphinx-web)"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  changes   to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  clean     to clean all build files/directories"
	@echo "  dist      to make a distribution-ready tree (installing Scipy in venv)"
	@echo "  doc-dist  to make a distribution-ready tree (assuming Scipy is installed)"
	@echo "  upload USERNAME=... RELEASE=... to upload built docs to docs.scipy.org"
	@echo "  show      to show the HTML output"

clean:
	-rm -rf build/* source/reference/generated source/.jupyterlite.doit.db


#------------------------------------------------------------------------------
# Automated generation of all documents
#------------------------------------------------------------------------------

# Build the current scipy version, and extract docs from it.
# We have to be careful of some issues:
#
# - Everything must be done using the same Python version
# - We must use eggs (otherwise they might override PYTHONPATH on import).
# - Different versions of easy_install install to different directories (!)
#

UPLOAD_DIR=/srv/docs_scipy_org/doc/scipy-$(RELEASE)

# `set -o pipefail` is specific to bash
SHELL = /bin/bash
SCIPYVER:=$(shell $(PYTHON) -c "import scipy; print(scipy.version.git_revision[:10])" | tail -c11 2>/dev/null)
GITVER ?= $(shell (cd ..; set -o pipefail && git rev-parse HEAD 2>/dev/null | cut -c1-10) || echo Unknown)

version-check:
ifeq "$(GITVER)" "Unknown"
	# @echo sdist build with unlabeled sources
else ifeq ("", "$(SCIPYVER)")
	@echo scipy not found, cannot build documentation without successful \"import scipy\"
	@exit 1
else ifneq ($(SCIPYVER),$(GITVER))
	@echo installed scipy $(SCIPYVER) != current repo git version \'$(GITVER)\'
	@echo use '"make dist"' or '"GITVER=$(SCIPYVER) make $(MAKECMDGOALS) ..."'
	@exit 1
else
	# for testing
	# @echo installed scipy $(SCIPYVER) matches git version $(GITVER); exit 1
endif

dist:
	install -d build
	rm -rf build/env
	$(PYTHON) -mvenv --system-site-packages build/env
	$(CURDIR)/build/env/bin/python -mpip install -r ../requirements/doc.txt
	$(CURDIR)/build/env/bin/python -mpip install ..
	make PYTHON="$(CURDIR)/build/env/bin/python" doc-dist

doc-dist: VERSIONWARNING=-t versionwarning

doc-dist: html
	-test -d build/htmlhelp || make htmlhelp-build
	-rm -rf build/dist
	mkdir -p build/dist
	cp -r build/html/* build/dist
	(cd build/html && zip -9qr ../dist/scipy-html.zip .)
	chmod ug=rwX,o=rX -R build/dist
	find build/dist -type d -print0 | xargs -0r chmod g+s
	cd build/dist && tar czf ../dist.tar.gz *

upload:
	# SSH must be correctly configured for this to work.
	# Assumes that ``make dist`` was already run
	# Example usage: ``make upload USERNAME=rgommers RELEASE=0.17.0``
	ssh $(USERNAME)@new.scipy.org mkdir -p $(UPLOAD_DIR)
	scp build/dist.tar.gz $(USERNAME)@new.scipy.org:$(UPLOAD_DIR)
	ssh $(USERNAME)@new.scipy.org tar xvC $(UPLOAD_DIR) \
	    -zf $(UPLOAD_DIR)/dist.tar.gz
	ssh $(USERNAME)@new.scipy.org mv $(UPLOAD_DIR)/scipy-html.zip \
	    $(UPLOAD_DIR)/scipy-html-$(RELEASE).zip
	ssh $(USERNAME)@new.scipy.org rm $(UPLOAD_DIR)/dist.tar.gz
	ssh $(USERNAME)@new.scipy.org ln -snf scipy-$(RELEASE) /srv/docs_scipy_org/doc/scipy

#------------------------------------------------------------------------------
# Basic Sphinx generation rules for different formats
#------------------------------------------------------------------------------

html: version-check html-build
html-build:
	mkdir -p build/html build/doctrees
	$(SPHINXBUILD) -WT --keep-going $(VERSIONWARNING) -b html $(ALLSPHINXOPTS) build/html $(FILES)

coverage: build version-check
	mkdir -p build/coverage build/doctrees
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) build/coverage $(FILES)
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

changes: version-check
	mkdir -p build/changes build/doctrees
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) build/changes $(FILES)
	@echo
	@echo "The overview file is in build/changes."

linkcheck: version-check
	mkdir -p build/linkcheck build/doctrees
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) build/linkcheck $(FILES)
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in build/linkcheck/output.txt."

show:
	@python -c "import webbrowser; webbrowser.open_new_tab('file://$(PWD)/build/html/index.html')"

=== subprojects/boost_math/math/test/compile_test/CMakeLists.txt ===
# Copyright 2021 Matt Borland
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

include_directories(../../include_private)
file(GLOB SRC_FILES CONFIGURE_DEPENDS "*.cpp")
boost_test(TYPE "compile" SOURCES ${SRC_FILES} COMPILE_DEFINITIONS BOOST_MATH_STANDALONE COMPILE_FEATURES cxx_std_17 LINK_LIBRARIES Boost::math Boost::multiprecision Boost::numeric_ublas Boost::unit_test_framework )

=== debian/changelog ===
scipy (1.16.2-5) unstable; urgency=medium

  * mips64el: skip test_nan_inputs[sph_harm]
  * hppa: skip all TestCubatureProblems
  * hurd-i386: skip test_tmean (test_mstats_basic.py)

 -- Drew Parsons <dparsons@debian.org>  Tue, 28 Oct 2025 21:57:53 +0100

scipy (1.16.2-4) unstable; urgency=medium

  * debian patch fix_stats_bivariate_normal_cdf_PR23815.patch fixes
    bivariate normal cdfs in stats. Needed by iminuit. Closes: #1109954
  * hppa: skip test_QRVS_shape_consistency
    [3-d_out2-size_in3-size_out3-qrng2-NumericalInversePolynomial]
  * hurd-i386: skip test_rankdata in test_mstats_basic.py (MemoryError)
  * debian/tests i386 with blis: skip test_sylvester test_cython
    test_sy_he_tri test_gbcon test_gh23278

 -- Drew Parsons <dparsons@debian.org>  Mon, 27 Oct 2025 01:21:53 +0100

scipy (1.16.2-3) unstable; urgency=medium

  * hurd-i386: skip test_exact_basic (MemoryError)
  * hppa: skip test_QRVS_shape_consistency
    [3-d_out2-1-size_out1-None-NumericalInversePolynomial]
  * debian/tests i386: skip test_two_generic_matrix_inputs with blis

 -- Drew Parsons <dparsons@debian.org>  Wed, 22 Oct 2025 19:15:46 +0200

scipy (1.16.2-2) unstable; urgency=medium

  * update build-time test skips
    - debian/rules hurd-i386: test_kurtosis (MemoryError)
    - hppa: test_scalar_output in TestCubatureProblems
  * debian/tests i386 with blis: skip test_eigh (linalg test_batch.py)

 -- Drew Parsons <dparsons@debian.org>  Sun, 19 Oct 2025 10:19:39 +0200

scipy (1.16.2-1exp2) experimental; urgency=medium

  * mips64el: skip test_nan_inputs[airye]
  * hppa: skip test_accuracy[numpy-case28]

 -- Drew Parsons <dparsons@debian.org>  Sun, 12 Oct 2025 16:17:35 +0200

scipy (1.16.2-1exp1) experimental; urgency=medium

  * New upstream release
  * i386: skip test_matmat (linalg batch test) with BLIS
  * hppa: add another case to test_QRVS_shape_consistency skips
  * hurd-i386: skip TestBoxcox and selected slower tests (iterative hop
    crash evolution marginals vector) to reduce test burden
    and avoid MemoryError
  * Build-Depends: python3-numpy-dev (for dh_numpy3)

 -- Drew Parsons <dparsons@debian.org>  Fri, 10 Oct 2025 17:31:07 +0200

=== debian/rules ===
--- 
+++ 
@@ -90,7 +90,7 @@
     SKIP_TEST_LIST += TestCephes TestEllipCarlson TestErf TestFresnel TestHyper
     SKIP_TEST_LIST += test_boost TestHyp1f1 test_nan_inputs[wofz] test_eval_chebyt_gh20129
     SKIP_TEST_LIST += test_sici_consistency test_shichi_consistency test_wrightomega
-    SKIP_TEST_LIST += test_cont_basic test_norm_logcdf
+    SKIP_TEST_LIST += test_cont_basic test_norm_logcdf test_nan_inputs[airye] test_nan_inputs[sph_harm]
 endif
 
 # https://github.com/scipy/scipy/issues/17839#issuecomment-1401780853
@@ -150,4 +150,3 @@
 	test_QRVS_shape_consistency[1-d_out1-size_in4-size_out4-None-NumericalInversePolynomial] \
 	test_QRVS_shape_consistency[1-d_out1-size_in4-size_out4-qrng1-NumericalInversePolynomial] \
 	test_QRVS_shape_consistency[1-d_out1-size_in4-size_out4-qrng2-NumericalInversePolynomial] \
-	test_QRVS_shape_consistency[1-d_out1-4-size_out2-qrng1-NumericalInversePolynomial] \
